<html>
<head>
  <title>Shamir Sır Paylaşım Şeması</title>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
  <meta http-equiv="X-UA-Compatible" content="IE=edge" />
  <meta name="viewport" content="width=device-width, initial-scale=1">

  <script type="text/javascript" src="jquery-1.10.2.js"></script>
  <!--<link rel="stylesheet" type="text/css" href="bootstrap-3.3.7-dist/css/bootstrap.css">
  <script type="text/javascript" src="bootstrap-3.3.7-dist/js/bootstrap.js"></script>-->
  <style>
    #divMap table, #divMap  th, #divMap  td {
        border: 1px solid black;
    }
    #divMap td {
      width: 100px;
      text-align: center;
    }
	table {
		border-collapse: collapse;
	}
    #divEncode {
      width: auto;
      height: auto;
      display: block;
      justify-content: center;
    }
	.greenBackground {
	  background-color: green;
	}
    .floatingDiv {
      float: left;
      width: 100%;
      height: auto;
      display: flex;
      justify-content: center;
      align-items: flex-end;
    }
  </style>

  <script type="text/javascript" src="calculationlib/matrixlib.js"></script>
  <script type="text/javascript" src="calculationlib/ecclib.js"></script>
  <script type="text/javascript" src="calculationlib/polynomial.js"></script>
  <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.6/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
  <!--<script type="text/javascript" src="MathJax/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>-->
  <script type="text/x-mathjax-config">
    MathJax.Hub.Config({tex2jax: {inlineMath: [['$','$'], ['\\(','\\)']]}});
    MathJax.Localization.setLocale("tr");
  </script>
  <script>
    var WriteFormula = function(divId, TeX) {
		var selector = "#" + divId;
		var selObj = $(selector)
		if(selObj.length > 0){
			var queue = MathJax.Hub.queue;
			var math = MathJax.Hub.getAllJax(divId)[0];
			queue.Push(
				function () { selObj.css('visibility','hidden') },
				//["resetEquationNumbers",MathJax.InputJax.TeX],
				["Text",math,"\\displaystyle{"+TeX+"}"],
				function () { selObj.css('visibility','visible') }
			);
		}
    }
    var AddFormula = function(container, name, tex) {
		var containerSelector = $('#' + container);
		if ($('#' + name).length == 0)
			containerSelector.append("<div id='" + name + "' style='text-align:center; visibility: visible; padding:10;'>");
		else $('#' + name).html("");

		$('#' + name).append($('<script type="math/tex">').text("\\displaystyle{"+tex+"}"));
		MathJax.Hub.Queue(
			//function () { $('#' + name).css('visibility','hidden')
			["Typeset",MathJax.Hub]
			//,function () { $('#' + name).css('visibility','visible') }
		);
	}
    var CreateInput = function(inputCount, q) {

		var text = "<table>";

		for (var i = 1; i < inputCount+1; i++) {
			text += "<tr>";
			text += "<td align='center'>" + i + "</td>";
			text += "<td><input type='text' style='text-align:center;' size='30' num=" + i + " id='txtInpt" + i + "' /></td>";
			text += "</tr>";
		}

		text += "</table>";
		return text;
	}
	var GetMap = function(){
		var map = { "a":0, "b":1, "c":2, "ç":3, "d":4, "e":5, "f":6, "g":7, "ğ":8,
					"h":9, "ı":10, "i":11, "j":12, "k":13, "l":14, "m":15, "n":16,
					"o":17, "ö":18, "p":19, "r":20, "s":21, "ş":22, "t":23, "u":24,
					"ü":25, "v":26, "y":27, "z":28, "x":29, "w":30, "q":31,
					"A":32, "B":33, "C":34, "Ç":35, "D":36, "E":37, "F":38, "G":39,
					"Ğ":40, "H":41, "I":42, "İ":43, "J":44, "K":45, "L":46, "M":47,
					"N":48, "O":49, "Ö":50, "P":51, "R":52, "S":53, "Ş":54, "T":55,
					"U":56, "Ü":57, "V":58, "Y":59, "Z":60, "X":61, "W":62, "Q":63,
					"1":64, "2":65, "3":66, "4":67, "5":68, "6":69, "7":70, "8":71,
					"9":72, "0":73,
					".":74, ",":75, ";":76, "+":77, "-":78, "*":79, "/":80, "&":81,
					"%":82, "(":83, ")":84, "[":85, "]":86, "{":87, "}":88, "'":89,
					"#":90, "=":91, "?":92, "!":93, "<":94, ">":95, "´":96, "|":97,
					"_":98, " ":99, "\"":100 };
		return map;
    }
    var GetReverseMap = function(){
		var map = GetMap();
		var map2 = {};
		for (var character in map){
			var val = map[character];
			//if(["%", "&", "{", "}", "#", "_"].indexOf(character) >= 0)
			//  character = "\\" + character;
			map2[val] = character;
		}
		return map2;
    }
    var WriteMap = function(map){
		var lineCount = 11;
		var map2 = {};
		for (var character in map)
			map2[map[character]] = character;

		var i = 1;
		var text = "<table><tr>";
		for (var character in map2) {
			text += "<td><b>" + map2[character] + "</b></td><td>" + character + "</td>";
			if (i % lineCount == 0)
				text += "</tr><tr>";
			i++;
			//AddFormula("divMap", "Char" + i, map2[character] + "\\rightarrow" + character);
		}
		text += "<tr/></table>"
		$("#divMap").append(text);
    }
  </script>
</head>

<body>

  <h2>Shamir Sır Paylaşım Şeması </h2>

  <div id="divMap"></div>

  <h3>Sırı Oluşturma</h2>
  <div id="divConstSecretParams">
    <table>
      <tr>
        <td>  <strong>q</strong>  </td>
        <td>  <input type="text" id="txtQ" value="101" readonly/>  </td>
      </tr>
      <tr>
        <td>  <strong>K</strong>  </td>
        <td>  <input type="text" id="txtK" value="6"/>  </td>
      </tr>
      <tr>
        <td>  <strong>N</strong>  </td>
        <td>  <input type="text" id="txtN" value="10"/>  </td>
      </tr>
      <tr>
        <td>  <strong>Sır</strong>  </td>
        <td>  <input type="text" id="txtSecret" value="test metni"/>  </td>
      </tr>
      <tr>
        <td> </td>
        <td>  <input type="button" id="btnConstructSecret" value="Sırrı Oluştur" />  </td>
      </tr>
	</table>
  </div>
  <div id="divEncode" ></div>
  <div id="divConstSecretResult"></div>

  <h3>Sırrı Çözme</h3>
  <div id="divFindSecretParams">
    <b>q:</b> <input type='text' id='txtQ2' value='101' readonly/> <br />
    <div id="divSecretInputs"></div>
    <input type='button' id='btnFindSecret' value='Sırrı Bul' />
  </div>
  <div id="divFindSecretResult"></div>



  <script type="text/javascript">

	var factorial = function(num) {
		var result  = 1;
		for(var i = 1; i <= num; i++)
			result *= i;
		return result;
	}
	var combination = function(n,k) {
		return factorial(n) / (factorial(k) * factorial(n-k));
	}
	var combinations = function(start, end) {
		var data = [];
		for (var i = start; i <= end; i++)
			data.push(i);
		
		var target = [];
		var result = get_combinations(target, data);
		
		return result;
	}
	var get_combinations = function(target, data) {
		
		var result = [];
		for (var i = 0; i < data.length; i++) {
			
			var new_target = target.slice(0);
			var new_data = data.slice(0);
			new_target.push(data[i]);
			new_data = new_data.slice(i+1);
			result.push(new_target);
			var r = get_combinations(new_target, new_data);
			for (j = 0; j < r.length; j++)
				result.push(r[j]);
		}
		return result;
	}
	var sortbylength = function(array) {
		for (var i = 1; i < array.length; i++) {
			for (var j = 0; j < array.length-i; j++) {
				if (array[j].length > array[j+1].length) {
					var tmp = array[j];
					array[j] = array[j+1];
					array[j+1] = tmp;
				}
			}
		}
		return array;
	}
	
	
	$(document).ready(function () {
		var map = GetMap();
		WriteMap(map);
		
		$("input[type='button']").click(function (e) {
			if (e.target.id == "btnConstructSecret") {

				$("#divEncode").html("");
				$("#divConstSecretResult").html("");
				$("#divFindSecretResult").html("");

				var q = parseInt($('#txtQ').val());
				var K = parseInt($('#txtK').val());
				var N = parseInt($('#txtN').val());
				var secret = $('#txtSecret').val();

				var message = [];
				for (var i = 0; i < secret.length; i++) {
					var line = parseInt(i / 30);
					if ($("#divEncodeLine" + line).length == 0)
						$("#divEncode").append("<div id='divEncodeLine" + line + "' class='floatingDiv'></div>")

					message.push(map[secret[i]]);
					var text =  secret[i] + "\\\\ \\downarrow \\\\" + map[secret[i]];
					AddFormula("divEncodeLine" + line, "MatCode" + i, text);
				}

				AddFormula("divConstSecretResult", "MatEmty", "\\qquad");

				var polynomials = [];
				for (var k = 0; k < message.length; k++) {
					var degreeOfPolynomial = K - 1;
					var polynomArray = [];
					for (var i = 0; i < degreeOfPolynomial; i++)
						polynomArray.push(parseInt(Math.random() * q));
					polynomArray.push(message[k]);
					while (polynomArray[0] == 0)
						polynomArray[0] = parseInt(Math.random() * q);
  					
					var polynom = new Polynomial(polynomArray, q);
					polynomials.push(polynom);

  					var polynomText = "f_{" + k + "}(" + polynom.Symbol + ")=";
  					polynomText += polynom.Text;
  					AddFormula("divConstSecretResult", "MathFormula" + k, polynomText);
				}

				var shares = [];
				var reverseMap = GetReverseMap();
				for (var i = 1; i <= N; i++) {
					share = "";
					for (var j = 0; j < polynomials.length; j++) {
						var val = message[j];
						var s = reverseMap[polynomials[j].Calculate(i)];
						if (s == undefined)
							console.log(polynomials[j].Calculate(i));
						share += s;
					}
					//AddFormula("divConstSecretResult", "MathShare" + i, "S_{" + i + "}=" + share);
					$("#divConstSecretResult").append("Share " + i + ":<b><input id='txtSharePart" + i + "' type='text'></b><br />");
					$("#txtSharePart" + i).val(share);
					shares.push(share);
				}


				$('#txtQ2').val(q);
				$("#divSecretInputs").html(CreateInput(N, q));

			}
			else if (e.target.id == "btnFindSecret") {

				$("#divFindSecretResult").html("");
				var q = parseInt($('#txtQ2').val());
				var shares = [];
				var maxLength = 0;
				$("[id^=txtInpt]").each(function() {
					if ($(this).val() != "") {
						shares.push([parseInt($(this).attr('num')),$(this).val()]);
						maxLength = Math.max($(this).val().length, maxLength);
					}
				});

				var interpolation = new Interpolation(q);
				var reverseMap = GetReverseMap();
				var secret = "";
				for (var i = 0; i < maxLength; i++) {
					var data = [];
					for (var j = 0; j < shares.length; j++)
						data.push([shares[j][0], map[shares[j][1][i]]]);
					var polynom = interpolation.Polynomial(data);
					var polynomText = "f_{" + i + "}(" + polynom.Symbol + ")=";
					polynomText += polynom.Text;
					secret += reverseMap[polynom.Calculate(0)];
					AddFormula("divFindSecretResult", "MathResult" + i, polynomText);
				}
				secret = secret.replace(/\&/g, '&amp;');
				secret = secret.replace(/\</g, '&lt;');
				secret = secret.replace(/\>/g, '&gt;');
				secret = secret.replace(/\"/g, '&quot;');
				$("#divFindSecretResult").append("Sır: <b>" + secret + "</b>");
				
				
				var originalSecret = $("#txtSecret").val();
				var n = parseInt($('#txtN').val());
				var combs = combinations(1, n);
				combs = sortbylength(combs);
				var text = "<table>";
				text += "<tr>"
				text += "<th>Katılımcılar</th>";
				text += "<th>Sonuç</th>";
				text += "<th>Doğru Konum Sayısı</th>";
				text += "</tr>";
					
				for (var i = 0; i < combs.length; i++) {
					
					var subset = "";
					var c = combs[i];
					for (var k = 0; k < c.length; k++) {
						subset += c[k];
						if (k < c.length-1)
							subset += ",";
					}
					
					
					secret = "";
					var shares = [];
					var maxLength = 0;
					for (var j = 0; j < c.length; j++) {
						var shareText = $("#txtSharePart" + c[j]).val();
						shares.push([ c[j], shareText ]);
						maxLength = Math.max(shareText.length, maxLength);
					}
					for (var j = 0; j < maxLength; j++) {
						var data = [];
						for (var k = 0; k < shares.length; k++)
							data.push([shares[k][0], map[shares[k][1][j]]]);
						var polynom = interpolation.Polynomial(data);
						secret += reverseMap[polynom.Calculate(0)];
					}
					var style = ""
					if (originalSecret == secret)
						style += "class='greenBackground'";
					
					var truePositions = 0;
					for (var j = 0; j < maxLength; j++) {
						if (secret[j] == originalSecret[j])
							truePositions += 1;
					}
					
					secret = secret.replace(/\&/g, '&amp;');
					secret = secret.replace(/\</g, '&lt;');
					secret = secret.replace(/\>/g, '&gt;');
					secret = secret.replace(/\"/g, '&quot;');
					
					text += "<tr>";
					text += "<td " + style + ">";
					text += subset;
					text += "</td>";
					text += "<td " + style + ">";
					text += secret;
					text += "</td>";
					text += "<td " + style + ">";
					text += truePositions;
					text += "</td>";
					text += "</tr>"
				}
				text += "</table>";
				$("#divFindSecretResult").append(text);
			}
		});
	});
	</script>
</body>

</html>
